• hdu 2955:Robberies(01背包)


    http://acm.hdu.edu.cn/showproblem.php?pid=2955

    Problem Description

    The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.
     


    For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


    His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

    Input

    The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
    Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

    Output

    For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

    Notes and Constraints
    0 < T <= 100
    0.0 <= P <= 1.0
    0 < N <= 100
    0 < Mj <= 100
    0.0 <= Pj <= 1.0
    A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

    Sample Input

    3
    0.04 3
    1 0.02
    2 0.03
    3 0.05
    0.06 3
    2 0.03
    2 0.03
    3 0.05
    0.10 3
    1 0.03
    2 0.02
    3 0.05

    Sample Output

    2
    4
    6

    题意分析:

    一个人要抢银行,每个银行有存的钱和被捕的概率,有一个可以接受的被逮捕概率,求在此概率下能抢到的最多的钱。

    解题思路:

    直接算被捕率不好算,所以反过来算逃脱概率,逃脱概率是每个银行的逃脱概率的乘积,把所有银行的钱加起来,求在抢i万元钱时的最大逃跑概率dp[i],再从后往前找到最大的可以抢的钱数。

    #include <stdio.h>
    #include <string.h>
    #include <algorithm>
    #define N 120
    using namespace std;
    struct date{
    	int v;
    	double t;
    }a[N];
    double dp[N*N];
    int main()
    {
    	int T, i, j, n, sum;
    	double s;
    	scanf("%d", &T);
    	while(T--)
    	{
    		sum=0;
    		scanf("%lf%d", &s, &n);
    		memset(dp, 0, sizeof(dp));
    		for(i=1; i<=n; i++)
    		{
    			scanf("%d%lf", &a[i].v, &a[i].t);
    			sum+=a[i].v;	
    			a[i].t=1-a[i].t;
    		}
    		dp[0]=1;
    		for(i=1; i<=n; i++)
    			for(j=sum; j>=a[i].v; j--)
    				dp[j]=max(dp[j], dp[j-a[i].v]*a[i].t);
    		for(i=sum; i>=0; i--)
    		{
    			if(dp[i]>=(1-s) || i==0)
    			{
    				printf("%d
    ", i);
    				break;
    			}
    		}
    	}
    	return 0;
    }
  • 相关阅读:
    [SCOI2016]幸运数字
    [CQOI2013]新Nim游戏
    POJ-2485 Highways---最小生成树中最大边
    最小生成树之kruskal算法
    POJ-1789 Truck History---最小生成树Prim算法
    最小生成树之prim算法
    POJ-1182 食物链---并查集(附模板)
    POJ-2993 Emag eht htiw Em Pleh---棋盘模拟
    POJ-2996 Help Me with the Game---模拟棋子
    POJ-1573 Robot Motion模拟
  • 原文地址:https://www.cnblogs.com/zyq1758043090/p/11852539.html
Copyright © 2020-2023  润新知